#ifndef _ADAM_H_
#define _ADAM_H_

#include "hls_linear_algebra.h"
#include "hls_math.h"
#include <ap_fixed.h>
#include <ap_int.h>

#define W_FIXED 32
#define IW_FIXED 16

#define MIN_NUMBER 0.0001220703125

typedef ap_fixed<W_FIXED, IW_FIXED> fixed_type;
//typedef float<W_FIXED, IW_FIXED> fixed_type;

#define B2_root 0.995115995

fixed_type Inverse_FixedInput_Fixed_0313(fixed_type number);

void Adam_Unit(fixed_type Weights[1], fixed_type Grad[1], fixed_type mt[1], fixed_type vt_root[1]);

void my_adam(fixed_type Weights[2][1], fixed_type Grad[2][1], fixed_type mt[2][1], fixed_type vt_root[2][1]);

#endif
