#include "Adam.h"
#include <iostream>
using namespace std;

int main(){
	fixed_type x[8][2] = {
			1,1,
			1,2,
			2,2,
			3,1,
			1,3,
			2,4,
			2,3,
			3,3
	};
	fixed_type y[8] = {3, 5, 6, 5, 7, 10, 8, 9};

	fixed_type Weights[2][1] = {0, 0};
	fixed_type Grad[2][1] = {0, 0};
	fixed_type mt[2][1] = {0, 0};
	fixed_type vt_root[2][1] = {0, 0};
	float test;

	for(int i=0; i<1000; i++){ //i<100000
		int j = i % 8;
		float print_error = 0;
		for (int m = 0; m < 8; m++){
			fixed_type result = x[m][0] * Weights[0][0] + x[m][1] * Weights[1][0];
			float error_batch = result - y[m];
			print_error = print_error + float(error_batch) * float(error_batch);
		}

		print_error = print_error / 16;

		cout << "Error is: "<< print_error << endl;

		if (print_error < 0.001) break;

		fixed_type error = x[j][0] * Weights[0][0] + x[j][1] * Weights[1][0] - y[j];

		Grad[0][0] = error * x[j][0];
		test = Grad[0][0];

		Grad[1][0] = error * x[j][1];
		test = Grad[1][0];

//		Adam<fixed_type, 2, 1>(Weights, Grad, mt, vt_root);
		my_adam(Weights, Grad, mt, vt_root);
		cout << "Weights are:" << Weights[0][0] << " " << Weights[1][0] << endl;

	}

	return 0;

}
